CentOS7升级Python3

一、查看当前python版本

[root@CentOS7 ~]# python -V
Python 2.7.5


二、下载新的python包并安装

进入python官网(https://www.python.org),选择需要的版本。此处我选择当前最新版本Python3.7.3

[root@CentOS7 ~]# yum -y install gcc gcc-c++ libffi-devel zlib*
[root@CentOS7 ~]# wget https://www.python.org/ftp/python/3.7.3/Python-3.7.3.tar.xz
[root@CentOS7 ~]# tar xvf Python-3.7.3.tar.xz 
[root@CentOS7 ~]# cd Python-3.7.3/
[root@CentOS7 Python-3.7.3]# ./configure
[root@CentOS7 Python-3.7.3]# make && make install


三、验证

[root@CentOS7 Python-3.7.3]# python -V
Python 2.7.5
[root@CentOS7 Python-3.7.3]# python3 -V
Python 3.7.3


四、设置3.X为默认版本

查看 Python 的路径,在 /usr/bin 下面。可以看到 python 链接的是 python 2.7,所以,执行 python 就相当于执行 python 2.7。

[root@CentOS7 ~]# ls -al /usr/bin | grep python
-rwxr-xr-x.   1 root root       11232 Dec  2  2016 abrt-action-analyze-python
lrwxrwxrwx.   1 root root           7 May 26  2017 python -> python2
lrwxrwxrwx.   1 root root           9 May 26  2017 python2 -> python2.7
-rwxr-xr-x.   1 root root        7136 Nov  6  2016 python2.7

将原来 python 的软链接重命名:

[root@CentOS7 ~]# mv /usr/bin/python /usr/bin/python.bak

将 python 链接至 python3:

[root@CentOS7 ~]# ln -s /usr/local/bin/python3 /usr/bin/python


五、配置yum

升级 Python 之后,由于将默认的 python 指向了 python3,yum 不能正常使用,需要编辑 yum 的配置文件,此时会出现下面的报错:

[root@CentOS7 Python-3.7.3]# yum list
  File "/usr/bin/yum", line 30
    except KeyboardInterrupt, e:

SyntaxError: invalid syntax

编辑以下两个文件

[root@CentOS7 ~]# vi /usr/bin/yum
[root@CentOS7 ~]# vi /usr/libexec/urlgrabber-ext-down

将开头的 #!/usr/bin/python 改为 #!/usr/bin/python2.7,保存退出即可。

评论列表

克拉封印
将第二部中的第5行 ./configure 替换成 ./configure --enable-optimizations
2020-02-25 17:38:56